<?php
  class Dreieck{
    private $p1; private $p2; private $p3;

    public function __construct($p1,$p2,$p3){
      $this->p1=$p1; $this->p2=$p2; $this->p3=$p3;
      // Gleichheit ist verboten
      if ($p1->getX()==$p2->getX()){
        if ($p1->getY()==$p2->getY()) $this->fehler();
      }
      if ($p1->getX()==$p3->getX()){
        if ($p1->getY()==$p3->getY()) $this->fehler();
      }
      if ($p2->getX()==$p3->getX()){
        if ($p2->getY()==$p3->getY()) $this->fehler();
      }
      if (($p1->getX()==$p2->getX())&&($p2->getX()==$p3->getX())) 
                                                         $this->fehler();
      if (($p1->getY()==$p2->getY())&&($p2->getY()==$p3->getY())) 
                                                         $this->fehler();
      // y=m*x+n
      // m=(y2-y1)/(x2-x1)
      $m=(($p2->getY())-($p1->getY()))/(($p2->getX())-($p1->getX()));
      // n1=n2=y2-m*x2
      $n=($p1->getY())-$m*($p1->getX());
      $y_gerade=$m*($p3->getX())+$n;
      if ($y_gerade==($p3->getY())) $this->fehler();
    }

    private function fehler(){
      die('Aus diesen 3 Punkten kann kein Dreieck gebildet werden!');
    }

    public function __toString(){
      return 'P1('.$this->p1.');P2('.$this->p2.');P3('.$this->p3.')';
    }
  }
?>
