<?php
  class Bruch{
    private $z=0;
    private $n=1;
    private static $anzahl=0;

    public function __construct($z,$n){
      $this->setZhler($z);
      $this->setNenner($n);
      Bruch::$anzahl++;
    }

    public function __destruct(){
      Bruch::$anzahl--;
    }

    public static function getAnzahl(){
      return Bruch::$anzahl;
		}
		
		public function __toString(){
		  return $this->getZhler()."/".$this->getNenner();
		}

    public function getZhler(){
      return $this->z;
    }
    public function getNenner(){
      return $this->n;
    }
  
    public function setZhler($z){
       $this->z=$z;
    }
    public function setNenner($n){
      $this->n=$n;
    }

    public function ausgeben(){
      return $this->getZhler()."/".$this->getNenner();
    }

    public function __call($func,$data){
      if ($func=="add"){
        if (is_integer($data[0])){
          $this->add_int($data[0]);
        }
        else{
          if ($data[0] instanceof Bruch){
            $this->add_bruch($data[0]);  
          }
        }
      }
    }

    private function add_int($int){
      $this->z += $int * $this->n;
    }
    private function add_bruch($b){
      $this->z = $this->z * $b->getNenner() + $this->n * $b->getZhler();
      $this->n *= $b->getNenner();
    }
  }
?>
