<?php
  class Student extends Person{
    private $matrNr; private $immatrikuliertSeit;
    private $praks=Array(); private $anzPraks=0; const MAX_PRAKS=5;

  public function __construct($matrNr,$name,$vorname,$strasse,$plz,$ort,
                                                   $immatrikuliertSeit){
    parent::__construct($name,$vorname,$strasse,$plz,$ort);
    $this->matrNr=$matrNr;
    $this->immatrikuliertSeit=$immatrikuliertSeit;
  }

    public function GetMatrNr(){
      return $this->matrNr;
    }
    public function getImmatrikuliertSeit(){
      return $this->immatrikuliertSeit;
    }
    public function getPraktika(){
      return $this->praks;
    } 

    public function anmelden($prak){
      if (($prak instanceof Praktikum)==FALSE) return FALSE;
      foreach (($this->praks) as $elem => $wert){
        if ($wert==$prak) return TRUE; // bereits angemeldet
      }
      if ($this->anzPraks==Student::MAX_PRAKS) return FALSE;
      // anmelden...
      $this->praks[$this->anzPraks]=$prak;
      $this->anzPraks++;
      // beim Praktikum anmelden
      if (($prak->anmelden($this))==FALSE){
        $this->anzPraks--;
        $this->praks[$this->anzPraks]=NULL;
        return FALSE;
      }
      return TRUE;
    }
  }
?>
