<?php
  class Fehler extends Exception{
    private $nummer; private $meldung;
    private $methode; private $kritisch=FALSE;

    public function __construct($nummer,$meldung,$methode,$kritisch){
      $this->nummer=$nummer; $this->meldung=$meldung;
      $this->methode=$methode; $this->kritisch=$kritisch;
    }
    
    public function getNummer(){
      return $this->nummer;
    }
    public function getMeldung(){
      return $this->meldung;
    }
    public function getMethode(){
      return $this->methode;
    }
    public function istKritisch(){
      return $this->kritisch;
    }
    public function __toString(){
      $ausgabe='Fehler Nr. '.$this->getNummer().'<br>';
      $ausgabe.='in Methode '.$this->getMethode().'<br>';
      $ausgabe.=$this->getMeldung().'<br>';
      return $ausgabe;
    }
  }
?>
