<?php
  class Singleton {
    private static $instance = NULL; 
    // privater Konstruktor:
    private function __construct() {} 
    // die statische Methode gibt die Instanz zurueck
    public static function getInstance() {
      if (self::$instance === NULL) self::$instance = new self;
      return self::$instance;
    }
   // das Klonen von auen muss verboten werden
   private function __clone() {}
  }
  // Aufruf der Instanz
  $singleton = Singleton::getInstance();
?>
