<?php
  class Aktienbestand{
    ...

    // Verkaufen
    public function addVerkauforder($value){
      if ($this->isVerkauft()){
        throw new Exception("addVerkauforder:Bestand ist bereits 
                                                          geschlossen!");
      }
      // Vereinfachung:
      if ($value->getAnzahl()!=$this->getAnzahl()){
        throw new Exception("addVerkauforder:Kann nur den gesamten 
                                                    Bestand verkaufen!");
      }
      $this->verkauft=TRUE;
      // Bilanz der Trading-Aktion -> Bilanz-Objekt
      $this->bilanz=new Bilanz($this,$value);
    }

    public function getBilanz(){
      if ($this->isVerkauft==FALSE){ // Bestand noch nicht verkauft...
        // -> Bilanz hngt vom aktuellen Kurs ab
        $bilanz=new Bilanz($this,$this->verkaufGebhren);
        return $bilanz->getDaten();
      }
      // Bilanz ist ggf. schon vorhanden aus dem Verkauf und
      // konstant, weil der Bestand ja bereits verkauft wurde
      return $this->bilanz->getDaten();
    }
  }
?>
